package hideandseek.managers;

import org.bukkit.Bukkit;
import java.io.InputStream;
import java.io.IOException;
import org.bukkit.configuration.Configuration;
import java.io.Reader;
import java.io.InputStreamReader;
import org.bukkit.configuration.file.YamlConfiguration;
import java.io.File;
import java.util.Iterator;
import hideandseek.HideAndSeek;
import org.bukkit.configuration.file.FileConfiguration;
import java.util.HashMap;

public class FilesManager
{
    private static FilesManager instance;
    private final HashMap<String, FileConfiguration> configurations;
    
    public FilesManager() {
        this.configurations = new HashMap<String, FileConfiguration>();
        FilesManager.instance = this;
        HideAndSeek.getInstance().reloadConfig();
        HideAndSeek.getInstance().getConfig().options().copyDefaults(true);
        HideAndSeek.getInstance().saveConfig();
        this.registerConfig("arenas.yml");
        this.registerConfig("items.yml");
        this.registerConfig("players.yml");
        this.registerConfig("ranks.yml");
        this.registerConfig("signs.yml");
        this.registerConfig("messages.yml");
        this.registerConfig("powerups.yml");
        this.registerConfig("trails_blacklist.yml");
        this.registerConfig("achievements.yml");
        for (final String var2 : this.configurations.keySet()) {
            this.reloadConfig(var2);
            this.configurations.get(var2).options().copyDefaults(true);
            this.saveConfig(var2);
        }
    }
    
    public static FilesManager getInstance() {
        return FilesManager.instance;
    }
    
    private void registerConfig(final String var1) {
        this.configurations.put(var1, (FileConfiguration)YamlConfiguration.loadConfiguration(new File(HideAndSeek.getInstance().getDataFolder(), var1)));
    }
    
    public FileConfiguration getConfig(final String var1) {
        return this.configurations.get(var1);
    }
    
    private void reloadConfig(final String var1) {
        final InputStream var2 = HideAndSeek.getInstance().getResource(var1);
        if (var2 != null) {
            final InputStreamReader var3 = new InputStreamReader(var2);
            final YamlConfiguration var4 = YamlConfiguration.loadConfiguration((Reader)var3);
            this.configurations.get(var1).setDefaults((Configuration)var4);
            try {
                var3.close();
                var2.close();
            }
            catch (final IOException var5) {
                var5.printStackTrace();
            }
        }
    }
    
    public void saveConfig(final String var1) {
        try {
            this.configurations.get(var1).save(new File(HideAndSeek.getInstance().getDataFolder(), var1));
        }
        catch (final IOException var2) {
            Bukkit.getConsoleSender().sendMessage("[躲猫猫] 无法保存 " + var1);
        }
    }
}
